Index: /trunk/include/VBox/AssertGuest.h
===================================================================
--- /trunk/include/VBox/AssertGuest.h	(revision 71609)
+++ /trunk/include/VBox/AssertGuest.h	(revision 71610)
@@ -1116,5 +1116,5 @@
 #define ASSERT_GUEST_LOGREL_FAILED() \
     do { \
-        ASSERT_GUEST_LOGREL_MSG1((const char *)0, __LINE__, __FILE__, __PRETTY_FUNCTION__); \
+        ASSERT_GUEST_LOGREL_MSG1("failed", __LINE__, __FILE__, __PRETTY_FUNCTION__); \
         ASSERT_GUEST_PANIC(); \
     } while (0)
@@ -1128,5 +1128,5 @@
 #define ASSERT_GUEST_LOGREL_FAILED_RETURN(a_rc) \
     do { \
-        ASSERT_GUEST_LOGREL_MSG1((const char *)0, __LINE__, __FILE__, __PRETTY_FUNCTION__); \
+        ASSERT_GUEST_LOGREL_MSG1("failed", __LINE__, __FILE__, __PRETTY_FUNCTION__); \
         ASSERT_GUEST_PANIC(); \
         return (a_rc); \
@@ -1139,5 +1139,5 @@
 #define ASSERT_GUEST_LOGREL_FAILED_RETURN_VOID() \
     do { \
-        ASSERT_GUEST_LOGREL_MSG1((const char *)0, __LINE__, __FILE__, __PRETTY_FUNCTION__); \
+        ASSERT_GUEST_LOGREL_MSG1("failed", __LINE__, __FILE__, __PRETTY_FUNCTION__); \
         ASSERT_GUEST_PANIC(); \
         return; \
@@ -1151,5 +1151,5 @@
     if (1) \
     { \
-        ASSERT_GUEST_LOGREL_MSG1((const char *)0, __LINE__, __FILE__, __PRETTY_FUNCTION__); \
+        ASSERT_GUEST_LOGREL_MSG1("failed", __LINE__, __FILE__, __PRETTY_FUNCTION__); \
         ASSERT_GUEST_PANIC(); \
         break; \
@@ -1166,5 +1166,5 @@
     if (1) \
     { \
-        ASSERT_GUEST_LOGREL_MSG1((const char *)0, __LINE__, __FILE__, __PRETTY_FUNCTION__); \
+        ASSERT_GUEST_LOGREL_MSG1("failed", __LINE__, __FILE__, __PRETTY_FUNCTION__); \
         ASSERT_GUEST_PANIC(); \
         a_Stmt; \
@@ -1181,5 +1181,5 @@
 #define ASSERT_GUEST_LOGREL_MSG_FAILED(a) \
     do { \
-        ASSERT_GUEST_LOGREL_MSG1((const char *)0, __LINE__, __FILE__, __PRETTY_FUNCTION__); \
+        ASSERT_GUEST_LOGREL_MSG1("failed", __LINE__, __FILE__, __PRETTY_FUNCTION__); \
         ASSERT_GUEST_LOGREL_MSG2(a); \
         ASSERT_GUEST_PANIC(); \
@@ -1197,5 +1197,5 @@
 #define ASSERT_GUEST_LOGREL_MSG_FAILED_STMT(a, a_Stmt) \
     do { \
-        ASSERT_GUEST_LOGREL_MSG1((const char *)0, __LINE__, __FILE__, __PRETTY_FUNCTION__); \
+        ASSERT_GUEST_LOGREL_MSG1("failed", __LINE__, __FILE__, __PRETTY_FUNCTION__); \
         ASSERT_GUEST_LOGREL_MSG2(a); \
         ASSERT_GUEST_PANIC(); \
@@ -1212,5 +1212,5 @@
 #define ASSERT_GUEST_LOGREL_MSG_FAILED_RETURN(a, a_rc) \
     do { \
-        ASSERT_GUEST_LOGREL_MSG1((const char *)0, __LINE__, __FILE__, __PRETTY_FUNCTION__); \
+        ASSERT_GUEST_LOGREL_MSG1("failed", __LINE__, __FILE__, __PRETTY_FUNCTION__); \
         ASSERT_GUEST_LOGREL_MSG2(a); \
         ASSERT_GUEST_PANIC(); \
@@ -1229,5 +1229,5 @@
 #define ASSERT_GUEST_LOGREL_MSG_FAILED_STMT_RETURN(a, a_Stmt, a_rc) \
     do { \
-        ASSERT_GUEST_LOGREL_MSG1((const char *)0, __LINE__, __FILE__, __PRETTY_FUNCTION__); \
+        ASSERT_GUEST_LOGREL_MSG1("failed", __LINE__, __FILE__, __PRETTY_FUNCTION__); \
         ASSERT_GUEST_LOGREL_MSG2(a); \
         ASSERT_GUEST_PANIC(); \
@@ -1244,5 +1244,5 @@
 #define ASSERT_GUEST_LOGREL_MSG_FAILED_RETURN_VOID(a) \
     do { \
-        ASSERT_GUEST_LOGREL_MSG1((const char *)0, __LINE__, __FILE__, __PRETTY_FUNCTION__); \
+        ASSERT_GUEST_LOGREL_MSG1("failed", __LINE__, __FILE__, __PRETTY_FUNCTION__); \
         ASSERT_GUEST_LOGREL_MSG2(a); \
         ASSERT_GUEST_PANIC(); \
@@ -1260,5 +1260,5 @@
 #define ASSERT_GUEST_LOGREL_MSG_FAILED_STMT_RETURN_VOID(a, a_Stmt) \
     do { \
-        ASSERT_GUEST_LOGREL_MSG1((const char *)0, __LINE__, __FILE__, __PRETTY_FUNCTION__); \
+        ASSERT_GUEST_LOGREL_MSG1("failed", __LINE__, __FILE__, __PRETTY_FUNCTION__); \
         ASSERT_GUEST_LOGREL_MSG2(a); \
         ASSERT_GUEST_PANIC(); \
@@ -1276,5 +1276,5 @@
     if (1)\
     { \
-        ASSERT_GUEST_LOGREL_MSG1((const char *)0, __LINE__, __FILE__, __PRETTY_FUNCTION__); \
+        ASSERT_GUEST_LOGREL_MSG1("failed", __LINE__, __FILE__, __PRETTY_FUNCTION__); \
         ASSERT_GUEST_LOGREL_MSG2(a); \
         ASSERT_GUEST_PANIC(); \
@@ -1293,5 +1293,5 @@
     if (1) \
     { \
-        ASSERT_GUEST_LOGREL_MSG1((const char *)0, __LINE__, __FILE__, __PRETTY_FUNCTION__); \
+        ASSERT_GUEST_LOGREL_MSG1("failed", __LINE__, __FILE__, __PRETTY_FUNCTION__); \
         ASSERT_GUEST_LOGREL_MSG2(a); \
         ASSERT_GUEST_PANIC(); \